/************************************************************************************
URSA -- Copyright (c) 2010, Predrag Janicic

This file is part of URSA
 
URSA is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.
 
URSA is WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.
**************************************************************************************/

#ifndef MINISATSOLVER_H_INCLUDED
#define MINISATSOLVER_H_INCLUDED

#include <vector>
#include "SATsolver.h"
#include "core/Solver.h"
#include "core/SolverTypes.h"

using namespace Minisat;

class MiniSATsolver : public SATsolver {

public:
   MiniSATsolver() { };
   ~MiniSATsolver() { };
   void InitSolver(unsigned int numVars);
   void addClause(vector<int> &clause); 
   bool solve();
   bool isTrueVar(unsigned int var);

private:
   Minisat::Solver solver;

};


#endif

